package speiger.src.coreengine.rendering.gui.font;

import java.util.List;
import java.util.Map;

import com.google.gson.JsonObject;

import speiger.src.collections.objects.lists.ObjectArrayList;
import speiger.src.collections.objects.maps.interfaces.Object2ObjectMap;
import speiger.src.coreengine.assets.AssetLocation;
import speiger.src.coreengine.assets.base.IAssetProvider;
import speiger.src.coreengine.assets.base.SteppedReloadableAsset;
import speiger.src.coreengine.rendering.gui.font.glyth.Glyth;
import speiger.src.coreengine.rendering.gui.font.glyth.IGlythSheetInfo;
import speiger.src.coreengine.rendering.gui.font.providers.IFontProvider;

public class FontManager extends SteppedReloadableAsset<Map<AssetLocation, List<IFontProvider>>> {
	private static final int TEXTURE_SIZE = 2048;
	Map<AssetLocation, FontGroup> fonts = Object2ObjectMap.builder().linkedMap();
	List<FontTexture> textures = new ObjectArrayList<>();
	
	@Override
	public String getName() { return null; }

	@Override
	public void destroy() {
		
	}
	
	@Override
	protected Map<AssetLocation, List<IFontProvider>> prepare(IAssetProvider provider) {
		return null;
	}
	
	@Override
	protected void apply(Map<AssetLocation, List<IFontProvider>> value, IAssetProvider provider) {
		
	}
	
	public Font createFont(float size) {
		return createFont(size, 1F);
	}
	
	public Font createFont(float size, float oversample) {
		return new Font(fonts, this::stitch, size, oversample);
	}
	
	private Glyth stitch(IGlythSheetInfo info) {
		for(int i = 0,m=textures.size();i<m;i++) {
			Glyth glyth = textures.get(i).build(info);
			if(glyth != null) return glyth;
		}
		FontTexture texture = new FontTexture(TEXTURE_SIZE, info.isColored());
		textures.add(texture);
		Glyth glyth = texture.build(info);
		return glyth;
	}
}